Index: /cpp/gdk/modelparts.h
===================================================================
--- /cpp/gdk/modelparts.h	(revision 103)
+++ /cpp/gdk/modelparts.h	(revision 104)
@@ -35,5 +35,5 @@
 PartBase(const SString& s):vis_style(s),mapped(0) {}
 ~PartBase();
-static const SString& getDefaultStyle(){static SString s("none"); return s;}
+static SString getDefaultStyle(){return SString("none");}
 MultiRange *mapped;
 enum PartBaseFlags { Selected=1 };
@@ -68,8 +68,7 @@
 {
 friend class Model;
-static const SString& getDefaultStyle();
+static SString getDefaultStyle();
 Part(double _mass,double _size,double _density,double _friction,double _ingest,double _assim)
-	:mass(_mass),size(_size),density(_density),friction(_friction),ingest(_ingest),assim(_assim),
-	PartBase(getDefaultStyle())
+	:PartBase(getDefaultStyle()),mass(_mass),size(_size),density(_density),friction(_friction),ingest(_ingest),assim(_assim)
 	{}
 public:
@@ -78,6 +77,6 @@
 Orient o;  ///< orientation in 3d space (rotation matrix)
 /// ParamInterface object is preferred way to get/set other properties.
-ParamInterface &extraProperties();
-ParamInterface &properties();
+Param extraProperties();
+Param properties();
 long refno;
 Pt3D rot;
@@ -104,7 +103,7 @@
 {
 friend class Model;
-static const SString& getDefaultStyle();
+SString getDefaultStyle();
 Joint(double _stamina,double _stif,double _rotstif,double _d)
-	:stamina(_stamina),stif(_stif),rotstif(_rotstif),PartBase(getDefaultStyle())
+	:PartBase(getDefaultStyle()),stamina(_stamina),stif(_stif),rotstif(_rotstif)
 	{d=Pt3D(_d,0,0);}
 public:
@@ -144,6 +143,6 @@
 
 /// ParamInterface object is preferred way to get/set other properties.
-ParamInterface &extraProperties();
-ParamInterface &properties();
+Param extraProperties();
+Param properties();
 
 // do not touch these:
@@ -182,5 +181,6 @@
 long visualhints;
 
-void *impl;
+//void *impl;
+int impl_count;
 bool active;
 int genactive;
@@ -290,5 +290,5 @@
 {
 friend class Model;
-static const SString& getDefaultStyle();
+static SString getDefaultStyle();
 
 struct NInput { Neuro *n; double weight; SString *info;
@@ -307,6 +307,6 @@
 public:
 enum NeuroFlags { HoldState=2 };
-ParamInterface &properties();
-ParamInterface &extraProperties();
+Param properties();
+Param extraProperties();
 
 void setInputInfo(int i,const SString& name,const SString &value);
Index: /cpp/gdk/multiparamload.cpp
===================================================================
--- /cpp/gdk/multiparamload.cpp	(revision 103)
+++ /cpp/gdk/multiparamload.cpp	(revision 104)
@@ -19,4 +19,29 @@
 breakcond=OnError;
 emptyparam.setParamTab(empty_paramtab);
+}
+
+int MultiParamLoader::findObject(const ExtObject &o)
+{
+for(int i=0;i<objects.size();i++)
+	if ((*objects(i))==o)
+		return i;
+return -1;
+}
+
+void MultiParamLoader::removeObject(const ExtObject &o)
+{
+int i=findObject(o);
+if (i>=0)
+	{
+	delete objects(i);
+	objects-=i;
+	}
+}
+
+void MultiParamLoader::clearObjects()
+{
+FOREACH(ExtObject*,o,objects)
+	delete o;
+objects.clear();
 }
 
@@ -102,7 +127,9 @@
 while (!finished())
 	{
-	if ((status==BeforeObject) || ((status==BeforeUnknown)&&lastclass))
-		{
-		lastclass->load(file);
+	if ((status==BeforeObject) || ((status==BeforeUnknown) && !lastobject.isEmpty()))
+		{
+		Param tmp_param;
+		ParamInterface *pi=lastobject.getParamInterface(tmp_param);
+		pi->load(file);
 		if ((status!=Finished) && maybeBreak(AfterObject))
 			break;
@@ -155,10 +182,10 @@
 		lastunknown=0;
 		lastunknown.append(t,linlen-1);
-		lastclass=0;
-		FOREACH(ParamInterface*,pi,params)
-			{
-			if (!strcmp(pi->getName(),lastunknown)) { lastclass=pi; break; }
-			}
-			if (lastclass)
+		lastobject.setEmpty();
+		FOREACH(ExtObject*,o,objects)
+			{
+			if (!strcmp(o->interfaceName(),lastunknown)) {lastobject=*o; break;}
+			}
+			if (!lastobject.isEmpty())
 				{
 				if (maybeBreak(BeforeObject))
@@ -244,6 +271,8 @@
 }
 
-int MultiParamLoader::loadObjectNow(ParamInterface *pi)
-{
+int MultiParamLoader::loadObjectNow(const ExtObject& o)
+{
+Param tmp_param;
+ParamInterface *pi=o.getParamInterface(tmp_param);
 pi->load(file);
 status=AfterObject;
Index: /cpp/gdk/multiparamload.h
===================================================================
--- /cpp/gdk/multiparamload.h	(revision 103)
+++ /cpp/gdk/multiparamload.h	(revision 104)
@@ -9,4 +9,5 @@
 #include "param.h"
 #include "virtfile.h"
+#include "extvalue.h"
 
 /** This is the general "framsticks-format" file parser for loading multiple objects.
@@ -37,13 +38,12 @@
 SListTempl<VirtFILE*> filestack;
 char ownfile;
-SList params;
+PtrListTempl<ExtObject*> objects;
 int status;
 SString lasterror, lastcomment, lastunknown;
-ParamInterface *lastclass;
+ExtObject lastobject;
 int breakcond;
 Param emptyparam;
 
 void init();
-void load();
 
 int maybeBreak(int cond)
@@ -58,8 +58,9 @@
 MultiParamLoader(const char* filename) {init(); load(filename);}
 
-~MultiParamLoader() {abort();}
+~MultiParamLoader() {abort();clearObjects();}
 
 void reset();
 
+void load(); //< use previously opened file
 void load(VirtFILE *f);
 void load(const char* filename);
@@ -69,7 +70,10 @@
     Note that registered classes will only work when the record name matches the class name, otherwise breakOn(BeforeUnknown) must be used and then getClassName() to check for the expected record.
  */
-void addClass(ParamInterface *pi) {params+=pi;}
-void removeClass(ParamInterface *pi) {params-=pi;}
-void clearClasses() {params.clear();}
+void addObject(ParamInterface *pi) {objects+=new ExtObject(pi);}
+void removeObject(ParamInterface *pi) {removeObject(ExtObject(pi));}
+void addObject(const ExtObject &o) {objects+=new ExtObject(o);}
+void removeObject(const ExtObject &o);
+int findObject(const ExtObject &o);
+void clearObjects();
 
 /** To be used in the main loop: while(event=loader.go()) { ... }
@@ -107,10 +111,11 @@
 
 /** Can be used BeforeObject and AfterObject */
-ParamInterface *getClass() {return lastclass;}
+ExtObject &getObject() {return lastobject;}
 /** Can be used BeforeUnknown, BeforeObject, AfterObject */
-const SString& getClassName() {return lastunknown;}
-const void setClassName(SString n) {lastunknown=n;}
+const SString& getObjectName() {return lastunknown;}
+const void setObjectName(SString n) {lastunknown=n;}
 /** Unknown object will be loaded if you set its class BeforeUnknown */
-void setClass(ParamInterface *pi) {lastclass=pi;}
+void setObject(ParamInterface *pi) {lastobject=ExtObject(pi);}
+void setObject(const ExtObject& o) {lastobject=o;}
 /** Can be used OnComment */
 const SString& getComment() {return lastcomment;}
@@ -118,7 +123,8 @@
 const SString& getError() {return lasterror;}
 /** Can be used BeforeObject and BeforeUnknown */
-int loadObjectNow(ParamInterface *pi);
+int loadObjectNow(ParamInterface *pi) {return loadObjectNow(ExtObject(pi));}
+int loadObjectNow(const ExtObject &o);
 /** Can be used BeforeObject */
-int loadObjectNow() {return loadObjectNow(getClass());}
+int loadObjectNow() {return loadObjectNow(getObject());}
 /** Can be used BeforeObject and BeforeUnknown.
     Object data will not be loaded. */
Index: /cpp/gdk/neurofactory.cpp
===================================================================
--- /cpp/gdk/neurofactory.cpp	(revision 103)
+++ /cpp/gdk/neurofactory.cpp	(revision 104)
@@ -7,7 +7,18 @@
 #include "param.h"
 #include "neuroimpl.h"
+#include "neurolibrary.h"
+
 #include NEURO_IMPL_FILES
 
-int NeuroFactory::used=0;
+NeuroImpl* NeuroFactory::getImplementation(NeuroClass *nc)
+{
+if (nc!=NULL)
+	{
+	std::map<NeuroClass*,NeuroImpl*>::iterator it=impl.find(nc);
+	if (it!=impl.end())
+		return it->second;
+	}
+return NULL;
+}
 
 NeuroImpl* NeuroFactory::createNeuroImpl(NeuroClass *nc)
@@ -15,5 +26,5 @@
 if (!nc) return 0;
 if (!nc->active) return 0;
-NeuroImpl* ni=(NeuroImpl*)nc->impl;
+NeuroImpl* ni=getImplementation(nc);
 if (!ni) return 0;
 ni=ni->makeNew();
@@ -31,6 +42,27 @@
 NeuroImpl* NeuroFactory::setImplementation(NeuroClass *nc,NeuroImpl *ni,bool deleteold)
 {
-NeuroImpl* old_ni=(NeuroImpl*)nc->impl;
-nc->impl=ni;
+if (nc==NULL) return NULL;
+std::map<NeuroClass*,NeuroImpl*>::iterator it=impl.find(nc);
+NeuroImpl* old_ni=NULL;
+if (it==impl.end())
+	{
+	if (ni!=NULL)
+		{
+		impl[nc]=ni;
+		nc->impl_count++;
+		}
+	return NULL;
+	}
+else
+	{
+	old_ni=it->second;
+	if (ni)
+		it->second=ni;
+	else
+		{
+		impl.erase(it);
+		nc->impl_count--;
+		}
+	}
 if (deleteold && old_ni) delete old_ni;
 return old_ni;
@@ -39,21 +71,33 @@
 #include NEURO_CLS_FACTORY
 
-void NeuroFactory::setImplementation()
+void NeuroFactory::setStandardImplementation()
 {
-if (!used)
-	{
-	SETIMPLEMENTATION
-	}
-used++;
+SETIMPLEMENTATION
 }
 
 void NeuroFactory::freeImplementation()
 {
-used--;
-if (!used)
-	{
-	for(int i=0;i<Neuro::getClassCount();i++)
-		setImplementation(Neuro::getClass(i),0);
-	}
+for(int i=0;i<Neuro::getClassCount();i++)
+	setImplementation(Neuro::getClass(i),0);
 }
 
+void NeuroFactory::removeUnimplemented()
+{
+SString removed;
+for(int i=0;i<Neuro::getClassCount();i++)
+	{
+	NeuroClass *nc=Neuro::getClass(i);
+	if (nc->impl_count==0)
+		{
+		removed+=nc->getName();
+		removed+=" ";
+		NeuroLibrary::staticlibrary.classes-=i;	
+		i--;
+		delete nc;
+		}
+	}
+if (removed.len())
+	FMprintf("NeuroFactory","removeUninmplemented",FMLV_INFO,
+	 "Removed Neuro classes: %s",(const char*)removed);
+}
+
Index: /cpp/gdk/neurofactory.h
===================================================================
--- /cpp/gdk/neurofactory.h	(revision 103)
+++ /cpp/gdk/neurofactory.h	(revision 104)
@@ -7,4 +7,5 @@
 
 #include "modelparts.h"
+#include <map>
 
 class NeuroImpl;
@@ -12,14 +13,16 @@
 class NeuroFactory
 {
+std::map<NeuroClass*,NeuroImpl*> impl;
 public:
-static NeuroImpl* setImplementation(NeuroClass *nc,NeuroImpl *ni,bool deleteold=1);
-static NeuroImpl* setImplementation(const SString& classname,NeuroImpl *ni,bool deleteold=1);
-static class NeuroImpl* createNeuroImpl(Neuro *n)
+NeuroImpl* setImplementation(NeuroClass *nc,NeuroImpl *ni,bool deleteold=1);
+NeuroImpl* setImplementation(const SString& classname,NeuroImpl *ni,bool deleteold=1);
+NeuroImpl* getImplementation(NeuroClass *nc);
+class NeuroImpl* createNeuroImpl(Neuro *n)
 	{NeuroClass *nc=n->getClass(); if (!nc) return 0; return createNeuroImpl(nc);}
-static class NeuroImpl* createNeuroImpl(NeuroClass *nc);
+class NeuroImpl* createNeuroImpl(NeuroClass *nc);
 
-static int used;
-static void setImplementation();
-static void freeImplementation();
+void setStandardImplementation();
+void freeImplementation();
+void removeUnimplemented();
 };
 
Index: /cpp/gdk/neuroimpl.cpp
===================================================================
--- /cpp/gdk/neuroimpl.cpp	(revision 103)
+++ /cpp/gdk/neuroimpl.cpp	(revision 104)
@@ -32,16 +32,11 @@
 #undef FIELDSTRUCT
 
-NeuroNetConfig::NeuroNetConfig()
+NeuroNetConfig::NeuroNetConfig(NeuroFactory *fac)
 	:par(nncfg_paramtab,this),
 	 randominit(0.01),
 	 nnoise(0),
-	 touchrange(1)
+	 touchrange(1),
+	 factory(fac)
 {}
-
-NeuroNetConfig& NeuroNetConfig::getGlobalConfig()
-{
-static NeuroNetConfig globalconfig;
-return globalconfig;
-}
 
 /////////////////////////////////////////////////////////////////
@@ -74,5 +69,5 @@
 for (i=0;n=mod.getNeuro(i);i++)
 	{
-	ni=NeuroFactory::createNeuroImpl(n);
+	ni=conf.factory->createNeuroImpl(n);
 	n->userdata[mytags_id]=ni;
 	if (!ni) { errorcount++;
@@ -205,10 +200,10 @@
 		chstate=chnewstate;
 	neuro->state=newstate;
-	if (NeuroNetConfig::getGlobalConfig().nnoise>0.0)
+	if (owner->getConfig().nnoise>0.0)
 		{
-		neuro->state+=RndGen.GaussStd()*NeuroNetConfig::getGlobalConfig().nnoise;
+		neuro->state+=RndGen.GaussStd()*owner->getConfig().nnoise;
 		if (channels>1)
 			for(int i=0;i<chstate.size();i++)
-				chstate(0)+=RndGen.GaussStd()*NeuroNetConfig::getGlobalConfig().nnoise;
+				chstate(0)+=RndGen.GaussStd()*owner->getConfig().nnoise;
 		}
 	}
@@ -272,5 +267,5 @@
 void NeuroImpl::readParam()
 {
-static Param par;
+Param par;
 if (!paramentries) return;
 par.setParamTab(paramentries);
Index: /cpp/gdk/neuroimpl.h
===================================================================
--- /cpp/gdk/neuroimpl.h	(revision 103)
+++ /cpp/gdk/neuroimpl.h	(revision 104)
@@ -17,9 +17,11 @@
 
 class Creature;
+class NeuroLibrary;
+class NeuroFactory;
 
 class NeuroNetConfig
 {
 public:
-NeuroNetConfig();
+NeuroNetConfig(NeuroFactory *fac);
 
 Param par;
@@ -28,5 +30,6 @@
 double touchrange;
 
-static NeuroNetConfig& getGlobalConfig();
+NeuroFactory *factory;
+//static NeuroNetConfig& getGlobalConfig();
 };
 
@@ -40,5 +43,5 @@
   public:
 
-NeuroSignals(NeuroImpl *n):owner(n),cr(0) {}
+NeuroSignals(NeuroImpl *n):cr(0),owner(n) {}
 
 #define STATRICKCLASS NeuroSignals
@@ -74,5 +77,6 @@
 static double getStateFromNeuro(Neuro *n);
 int getErrorCount() {return errorcount;}
-NeuroNetImpl(Model& model, NeuroNetConfig& conf = NeuroNetConfig::getGlobalConfig()
+NeuroNetConfig &getConfig() {return config;}
+NeuroNetImpl(Model& model, NeuroNetConfig& conf
 #ifdef NEURO_SIGNALS
 , ChannelSpace *ch=0
@@ -198,16 +202,16 @@
 /** don't access directly */
 double newstate;
+NeuroNetImpl *owner;
+/** will be used by readParam() method, if not null  */
+ParamEntry *paramentries; // no extra properties if ==0
 
 #ifdef NEURO_SIGNALS
 NeuroSignals sigs;
-#endif
-NeuroNetImpl *owner;
 ExtObject sigs_obj;
+#endif
 
 /** "virtual constructor" - NeuroFactory uses this method to create the proper implementation object.
     subclasses must return new object here. */
 virtual NeuroImpl* makeNew() {return 0;} // 
-/** will be used by readParam() method, if not null  */
-ParamEntry *paramentries; // no extra properties if ==0
 /** read additional properties from "moredata" field of the originating Neuro */
 void readParam();
@@ -247,5 +251,5 @@
 void validateNeuroState(double& st) {if (st<=-1e10) st=-1e10; else if (st>1e10) st=1e10;}
 
-NeuroImpl():owner(0),neuro(0),newstate(0),paramentries(0),simorder(1),status(BeforeInit),channels(1),fields_param(0),fields_object(0)
+NeuroImpl():simorder(1),channels(1),fields_param(0),fields_object(0),status(BeforeInit),neuro(0),newstate(0),owner(0),paramentries(0)
 #ifdef NEURO_SIGNALS
 ,sigs(this),sigs_obj(&NeuroSignals::getStaticParam(),&sigs)
Index: /cpp/gdk/neurolibrary.cpp
===================================================================
--- /cpp/gdk/neurolibrary.cpp	(revision 103)
+++ /cpp/gdk/neurolibrary.cpp	(revision 104)
@@ -25,4 +25,10 @@
 if (i<0) return 0;
 return getClass(i);
+}
+
+SString NeuroLibrary::getClassName(int classindex)
+{
+NeuroClass *cl=getClass(classindex);
+return cl? cl->getName() : SString();
 }
 
Index: /cpp/gdk/neurolibrary.h
===================================================================
--- /cpp/gdk/neurolibrary.h	(revision 103)
+++ /cpp/gdk/neurolibrary.h	(revision 104)
@@ -22,4 +22,5 @@
 int findClassIndex(const SString& classname, bool activeonly=1);
 NeuroClass* getClass(int classindex) {return (NeuroClass*)classes(classindex);}
+SString getClassName(int classindex);
 int getClassCount() {return classes.size();}
 void removeClass(int i);
Index: /cpp/gdk/neurotest.cpp
===================================================================
--- /cpp/gdk/neurotest.cpp	(revision 103)
+++ /cpp/gdk/neurotest.cpp	(revision 104)
@@ -80,6 +80,8 @@
 if (!m.getNeuroCount()) {puts("no neural network");return 1;}
 printf("%d neurons,",m.getNeuroCount());
-NeuroFactory::setImplementation();
-NeuroNetImpl *nn=new NeuroNetImpl(m);
+NeuroFactory neurofac;
+neurofac.setStandardImplementation();
+NeuroNetConfig nn_config(&neurofac);
+NeuroNetImpl *nn=new NeuroNetImpl(m,nn_config);
 int i; Neuro *n;
 if (!nn->getErrorCount()) printf(" no errors\n");
@@ -138,4 +140,4 @@
 	nn->simulateNeuroNet();
 	}
-NeuroFactory::freeImplementation();
+neurofac.freeImplementation();
 }
Index: /cpp/gdk/param.cpp
===================================================================
--- /cpp/gdk/param.cpp	(revision 103)
+++ /cpp/gdk/param.cpp	(revision 104)
@@ -231,4 +231,6 @@
 }
 
+const char* ParamInterface::SERIALIZATION_PREFIX="@Serialized:";
+
 int ParamInterface::saveprop(VirtFILE* f,int i,const char* p,bool force)
 {
@@ -243,5 +245,12 @@
 err|=(fputs(p,f)==EOF); fputc(':',f);
 cr=0;
-ws=get(i);
+if (*typ=='x')
+	{
+	ExtValue ex;
+	get(i,ex);
+	ws=SString(SERIALIZATION_PREFIX)+ex.serialize();
+	}
+else
+	ws=get(i);
 quoteTilde(ws);
 w=ws;
@@ -497,8 +506,14 @@
 	{
 	ExtValue e;
-	if (isdigit(*v)||((*v=='-')&&isdigit(v[1])))
-		{
-		if (strchr(v,'.')) e.setDouble(atof(v));
-		else e.setInt(atol(v));
+	const char* after;
+	if (!strncmp(v,SERIALIZATION_PREFIX,strlen(SERIALIZATION_PREFIX)))
+		{
+		after=e.deserialize(v+strlen(SERIALIZATION_PREFIX));
+		if ((after==NULL)||(*after))
+			FMprintf("ParamInterface","set",FMLV_WARN,"serialization format mismatch in %s.%s",(getName()?getName():"<Unknown>"),id(i));
+		}
+	else if ((after=e.parseNumber(v))&&(*after==0)) //consumed the whole string
+		{
+		//OK!
 		}
 	else
@@ -566,5 +581,5 @@
 long SimpleAbstractParam::getInt(int i)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->fun1)
@@ -582,5 +597,5 @@
 double SimpleAbstractParam::getDouble(int i)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->fun1)
@@ -598,5 +613,5 @@
 SString SimpleAbstractParam::getString(int i)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->fun1)
@@ -614,5 +629,5 @@
 ExtObject SimpleAbstractParam::getObject(int i)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->fun1)
@@ -630,5 +645,5 @@
 ExtValue SimpleAbstractParam::getExtValue(int i)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->fun1)
@@ -649,8 +664,8 @@
 int SimpleAbstractParam::setInt(int i,long x)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->flags&PARAM_READONLY) return PSET_RONLY;
-long xcopy=x; //only needed for helpful printed messages: retain original, requested value of x because it may be changed below
+long xcopy=x; //only needed for messageOnExceedRange(): retain original, requested value of x because it may be changed below
 long a=0,b=0;
 int result=0;
@@ -684,8 +699,8 @@
 int SimpleAbstractParam::setDouble(int i,double x)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->flags&PARAM_READONLY) return PSET_RONLY;
-double xcopy=x; //only needed for helpful printed messages: retain original, requested value of x because it may be changed below
+double xcopy=x; //only needed for messageOnExceedRange(): retain original, requested value of x because it may be changed below
 double a=0,b=0;
 int result=0;
@@ -719,10 +734,10 @@
 int SimpleAbstractParam::setString(int i,const SString& x)
 {
-static ExtValue v;
-static SString vs;
+ExtValue v;
+SString vs;
 const SString *xx=&x;
 ParamEntry *pe=entry(i);
 if (pe->flags&PARAM_READONLY) return PSET_RONLY;
-SString xcopy=x; //only needed for helpful printed messages: retain original, requested value of x because it may be changed below
+SString xcopy=x; //only needed for messageOnExceedRange(): retain original, requested value of x because it may be changed below
 const char* t=pe->type+1;
 while(*t) if (*t==' ') break; else t++;
@@ -759,8 +774,8 @@
 int SimpleAbstractParam::setObject(int i,const ExtObject& x)
 {
-static ExtValue v;
+ExtValue v;
 ParamEntry *pe=entry(i);
 if (pe->flags&PARAM_READONLY) return PSET_RONLY;
-ExtObject xcopy=x; //only needed for helpful printed messages: retain original, requested value of x because it may be changed below
+ExtObject xcopy=x; //only needed for messageOnExceedRange(): retain original, requested value of x because it may be changed below
 if (pe->fun2)
 	{
Index: /cpp/gdk/param.h
===================================================================
--- /cpp/gdk/param.h	(revision 103)
+++ /cpp/gdk/param.h	(revision 104)
@@ -151,4 +151,6 @@
 void load(VirtFILE*);
 void load2(const SString &,int &);
+
+static const char* SERIALIZATION_PREFIX;
 };
 
@@ -221,5 +223,6 @@
 	@param n Param's name
 */
-SimpleAbstractParam(void* o=0,const char*n=0):object(o),myname(n),dontcheckchanges(0) {}
+SimpleAbstractParam(void* o=0,const char*n=0):myname(n),dontcheckchanges(0),object(o) {}
+void setDontCheckChanges(bool x) {dontcheckchanges=x;}
 
 void select(void *o) {object=o;}
Index: /cpp/gdk/serialtest.cpp
===================================================================
--- /cpp/gdk/serialtest.cpp	(revision 104)
+++ /cpp/gdk/serialtest.cpp	(revision 104)
@@ -0,0 +1,93 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#include "collectionobj.h"
+
+void printIndent(int indent)
+{
+for(int i=0;i<indent;i++)
+	putchar(' ');
+}
+
+struct Trace
+{
+ExtObject object;
+Trace *previous;
+bool isAlreadyVisited(const ExtObject& o)
+	{
+	if (object==o) return true;
+	if (previous) return previous->isAlreadyVisited(o);
+	return false;
+	}
+};
+
+void print(ExtValue* v,int indent=0,Trace *prev_trace=NULL)
+{
+printIndent(indent);
+if (!v)
+	{puts("null"); return;}
+
+switch(v->getType())
+	{
+	case TUnknown: puts("null"); return;
+	case TInt: printf("int:"); break;
+	case TDouble: printf("double:"); break;
+	case TString: printf("string:"); break;
+	case TObj:
+		{
+		Trace next_trace={v->getObject(),prev_trace};
+		printf("%s object:",v->getObject().interfaceName());
+		if (prev_trace && prev_trace->isAlreadyVisited(next_trace.object))
+			{
+			printf(" already visited - breaking recursion\n");
+			return;
+			}
+		VectorObject *vec=VectorObject::fromObject(v->getObject());
+		if (vec)
+			{
+			printf("\n");
+			for(int i=0;i<vec->data.size();i++)
+				print((ExtValue*)vec->data(i),indent+3,&next_trace);
+			return;
+			}
+		DictionaryObject *dict=DictionaryObject::fromObject(v->getObject());
+		if (dict)
+			{
+			printf("\n");
+			for(HashEntryIterator it(dict->hash);it.isValid();it++)
+				{
+				printIndent(indent+3);
+				printf("key \"%s\"\n",(const char*)it->key);
+				print((ExtValue*)it->value,indent+6,&next_trace);
+				}
+			return;
+			}
+		}
+	}
+puts((const char*)v->getString());
+}
+
+int main(int argc,char*argv[])
+{
+const char* in= (argc>1) ? argv[1] : "[1,2,3,null,{\"x\":3.4,\"y\":[7,77,777]},4]";
+
+// note: this is not an example of how to read a param field, but only a special case where the input data was
+// previously identified as "serialized" and the "@Serialized:" prefix was already removed
+
+printf("DESERIALIZATION TEST\n"
+       "input string = %s\n",in);
+ExtValue v;
+const char* ret=v.deserialize(in);
+if (ret==NULL)
+	{
+	printf("failed!\n");
+	return 1;
+	}
+else
+	{
+	printf("OK, consumed %d of %d characters\n\n",ret-in,strlen(in));
+	print(&v);
+	return 0;
+	}
+}
Index: /cpp/gdk/sstring.cpp
===================================================================
--- /cpp/gdk/sstring.cpp	(revision 103)
+++ /cpp/gdk/sstring.cpp	(revision 104)
@@ -7,4 +7,14 @@
 #include "nonstd_stl.h"
 #include "extvalue.h"
+
+#ifdef MULTITHREADED
+#include <pthread.h>
+static pthread_mutex_t sstring_ref_lock;
+#define REF_LOCK pthread_mutex_lock(&sstring_ref_lock);
+#define REF_UNLOCK pthread_mutex_unlock(&sstring_ref_lock)
+#else
+#define REF_LOCK 
+#define REF_UNLOCK 
+#endif
 
 static int guessMemSize(int request, int memhint)
@@ -96,5 +106,7 @@
 SString::~SString()
 {
+REF_LOCK;
 detach();
+REF_UNLOCK;
 }
 
@@ -102,4 +114,5 @@
 {
 buf=new SBuf(x);
+memhint=-1;
 }
 
@@ -113,6 +126,14 @@
 SString::SString(const SString &from)
 {
-buf=from.buf;
-if (buf->size) buf->refcount++;
+if (from.buf==&SBuf::empty())
+	buf=&SBuf::empty();
+else
+	{
+	REF_LOCK;
+	buf=from.buf;
+	if (buf->size)
+		buf->refcount++;
+	REF_UNLOCK;
+	}
 memhint=-1;
 }
@@ -163,5 +184,7 @@
 {
 if (ensuresize<0) ensuresize=len();
+REF_LOCK;
 detachCopy(ensuresize);
+REF_UNLOCK;
 appending=buf->used;
 return buf->txt;
@@ -176,5 +199,7 @@
 char *SString::directAppend(int maxappend)
 {
+REF_LOCK;
 detachCopy(buf->used+maxappend);
+REF_UNLOCK;
 appending=buf->used;
 return buf->txt+appending;
@@ -208,5 +233,7 @@
 {
 if (!count) return;
+REF_LOCK;
 detachCopy(buf->used+count);
+REF_UNLOCK;
 buf->append(txt,count);
 }
@@ -230,5 +257,7 @@
 if (!ch) chlen=0;
 else if (chlen<0) chlen=strlen(ch);
+REF_LOCK;
 detachEmpty(chlen);
+REF_UNLOCK;
 memcpy(buf->txt,ch,chlen);
 buf->txt[chlen]=0; buf->used=chlen;
@@ -243,7 +272,9 @@
 {
 if (s.buf==buf) return;
+REF_LOCK;
 detach();
 buf=s.buf;
 if (buf->size) buf->refcount++;
+REF_UNLOCK;
 }
 ///////////////////////////////////////
@@ -306,23 +337,23 @@
 }
 
-const SString& SString::valueOf(int i)
-{
-static SString t;
+SString SString::valueOf(int i)
+{
+SString t;
 sprintf(t.directWrite(20),"%d",i); t.endWrite();
 return t;
 }
-const SString& SString::valueOf(long i)
-{
-static SString t;
+SString SString::valueOf(long i)
+{
+SString t;
 sprintf(t.directWrite(20),"%d",i); t.endWrite();
 return t;
 }
-const SString& SString::valueOf(double d)
-{
-static SString t;
+SString SString::valueOf(double d)
+{
+SString t;
 sprintf(t.directWrite(20),"%g",d); t.endWrite();
 return t;
 }
-const SString& SString::valueOf(const SString& s)
+SString SString::valueOf(const SString& s)
 {
 return s;
Index: /cpp/gdk/sstring.h
===================================================================
--- /cpp/gdk/sstring.h	(revision 103)
+++ /cpp/gdk/sstring.h	(revision 104)
@@ -157,8 +157,8 @@
 char charAt(int pos) const {return buf->txt[pos];}
 
-static const SString& valueOf(int);
-static const SString& valueOf(long);
-static const SString& valueOf(double);
-static const SString& valueOf(const SString&); //tylko do kompletu zeby mozna uzyc tej funkcji nie martwiac sie o typ argumentu
+static SString valueOf(int);
+static SString valueOf(long);
+static SString valueOf(double);
+static SString valueOf(const SString&); //tylko do kompletu zeby mozna uzyc tej funkcji nie martwiac sie o typ argumentu
 static SString valueOf(const ExtValue&); //tylko do kompletu zeby mozna uzyc tej funkcji nie martwiac sie o typ argumentu
 static SString valueOf(const ExtObject&); //tylko do kompletu zeby mozna uzyc tej funkcji nie martwiac sie o typ argumentu
Index: /cpp/gdk/stderrors.cpp
===================================================================
--- /cpp/gdk/stderrors.cpp	(revision 104)
+++ /cpp/gdk/stderrors.cpp	(revision 104)
@@ -0,0 +1,34 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2013  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#include "stderrors.h"
+#include "sstringutils.h"
+#include "framsg.h"
+
+bool listIndexCheck(SList* list,int index,char* msgobj,char* msgfun)
+{
+	int size=list->size();
+if ((index<0)||(index>=size))
+	{
+	if (size>0) 
+		FMprintf(msgobj,msgfun,FMLV_ERROR,"Invalid index %d (allowed range is 0..%d)",index,size-1);
+	else
+		FMprintf(msgobj,msgfun,FMLV_ERROR,"Invalid index %d (this list is empty)",index);
+	return 0;
+	}
+return 1;
+}
+
+SString stringCheck(SString& in,char* msgobj,char* msgfun,char* msg,SString (*checker)(SString& in))
+{
+if (!checker)
+	checker=trim;
+SString corrected=checker(in);
+if (corrected!=in)
+	{
+	SString msg2=SString(msg)+": \"%s\" (adjusted to \"%s\")";
+	FMprintf(msgobj,msgfun,FMLV_WARN,(const char*)msg2,(const char*)in,(const char*)corrected);
+	}
+return corrected;
+}
Index: /cpp/gdk/stderrors.h
===================================================================
--- /cpp/gdk/stderrors.h	(revision 104)
+++ /cpp/gdk/stderrors.h	(revision 104)
@@ -0,0 +1,14 @@
+// This file is a part of the Framsticks GDK library.
+// Copyright (C) 2002-2013  Szymon Ulatowski.  See LICENSE.txt for details.
+// Refer to http://www.framsticks.com/ for further information.
+
+#ifndef _STDERRORS_H_
+#define _STDERRORS_H_
+
+#include "list.h"
+#include "sstring.h"
+
+bool listIndexCheck(SList* list,int index,char* msgobj,char* msgfun);
+SString stringCheck(SString& in,char* msgobj,char* msgfun,char* msg,SString (*checker)(SString& in)=0);
+
+#endif
Index: /cpp/gdk/stdouterr.cpp
===================================================================
--- /cpp/gdk/stdouterr.cpp	(revision 103)
+++ /cpp/gdk/stdouterr.cpp	(revision 104)
@@ -1,4 +1,4 @@
 // This file is a part of the Framsticks GDK library.
-// Copyright (C) 2002-2011  Szymon Ulatowski.  See LICENSE.txt for details.
+// Copyright (C) 2002-2013  Szymon Ulatowski.  See LICENSE.txt for details.
 // Refer to http://www.framsticks.com/ for further information.
 
@@ -12,13 +12,12 @@
 void StdoutErrorHandler::handle(const char *o,const char *m,const char *bl,int w)
 {
-static char* level[]={"DEBUG","INFO","WARN","ERROR","CRITICAL"};
 if (w<-1) w=-1; else if (w>3) w=3;
 #ifdef SHP
-AppLog("[%s] %s::%s - %s\n",level[w+1],o,m,bl);
+AppLog("[%s] %s::%s - %s\n",MSG_LEVEL[w+1],o,m,bl);
 #else
 if (file)
-	file->printf("[%s] %s::%s - %s\n",level[w+1],o,m,bl);
+	file->printf("[%s] %s::%s - %s\n",MSG_LEVEL[w+1],o,m,bl);
 else
-	printf("[%s] %s::%s - %s\n",level[w+1],o,m,bl);
+	printf("[%s] %s::%s - %s\n",MSG_LEVEL[w+1],o,m,bl);
 #endif
 }
Index: /cpp/gdk/threads.h
===================================================================
--- /cpp/gdk/threads.h	(revision 104)
+++ /cpp/gdk/threads.h	(revision 104)
@@ -0,0 +1,60 @@
+#ifndef _THREADS_H_
+#define _THREADS_H_
+
+#ifdef MULTITHREADED
+
+#include <pthread.h>
+
+template<class T> class ThreadSingleton
+{
+pthread_key_t mt_key;
+
+  public:
+
+ThreadSingleton()
+ {
+ pthread_key_create(&mt_key,&destructor);
+ }
+
+static void destructor(void* o)
+ {
+ if (o)
+	 delete (T*)o;
+ }
+
+T* set(T* new_o)
+ {
+ T* o=(T*)pthread_getspecific(mt_key);
+ pthread_setspecific(mt_key,new_o);
+ return o;
+ }
+
+T* get()
+ {
+ T* o=(T*)pthread_getspecific(mt_key);
+ if (!o)
+	 {
+	 o=new T();
+	 pthread_setspecific(mt_key,o);
+	 }
+ return o;
+ }
+
+T& getref() {return *get();}
+};
+
+#else
+
+template<class T> class ThreadSingleton
+{
+T object;
+
+  public:
+
+T* get() {return &object;}
+T& getref() {return object;}
+};
+
+#endif
+
+#endif
